package vm

import (
	"context"
	"github.com/jinzhu/copier"
	"github.com/pkg/errors"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/helper/xerr"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/repository/result"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/utils"
	"gitlink.org.cn/JointCloud/pcm-openstack/openstack"
	"k8s.io/apimachinery/pkg/util/json"

	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/svc"
	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type UnRescueLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewUnRescueLogic(ctx context.Context, svcCtx *svc.ServiceContext) *UnRescueLogic {
	return &UnRescueLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *UnRescueLogic) UnRescue(req *types.UnRescueServerReq) (resp *types.UnRescueServerResp, err error) {
	// todo: add your logic here and delete this line
	UnRescueServerReq := &openstack.UnRescueServerReq{}
	err = copier.CopyWithOption(UnRescueServerReq, req, copier.Option{Converters: utils.Converters})
	UnRescueServerResp, err := l.svcCtx.OpenstackRpc.UnRescue(l.ctx, UnRescueServerReq)
	if err != nil {
		return nil, errors.Wrapf(xerr.NewErrMsg("c端创建失败"), "c端创建失败 : %v ,req:%+v", err, req)
	}
	marshal, err := json.Marshal(&UnRescueServerResp)
	if err != nil {
		return nil, result.NewDefaultError(err.Error())
	}
	json.Unmarshal(marshal, &resp)
	err = copier.CopyWithOption(&resp, &UnRescueServerResp, copier.Option{Converters: utils.Converters})
	return resp, err
}
